﻿
namespace Composite
{
    abstract class Tree
    {
        public string Name
        {
            get;
            private set;
        }
        public Tree Parent
        {
            get;
            set;
        }
        public int Level
        {
            get
            {
                int level = 0;
                Tree ancestor = Parent;
                while(ancestor!=null)
                {
                    level++;
                    ancestor = ancestor.Parent;
                }
                return level;
            }
        }
        public int Size
        {
            get
            {
                return Name.Length + Level*2;
            }
        }
        public Tree(string name)
        {
            Name = name;
            Parent = null;
        }
        public abstract void View();
        public virtual void AddChild(Tree child) {   }
        public virtual void RemoveChild(Tree child){  }

    }
}
